var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../../scripts/prettify.js\"></script><script src=\"../../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>説明された Python API 1.0 Hello World のサンプル</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>説明された Python API 1.0 Hello World のサンプル</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"説明された-python-api-1.0-hello-world-のサンプル\"></a></div>\n\
<p>Hello World のサンプルは、Maya Python API 1.0 を使用するプラグイン開発の重要な構成要素をいくつか示します。</p>\n\
<p>Python 関数とプラグインの詳細については、「<a href=\'#!/url=./dev_help/Maya-Python-API/Maya-Python-API-1-0.html\' title=\'\'>Maya Python API</a>」セクションを参照してください。</p>\n\
<div class=\'section\'><a id=\"コマンド-プラグインは-mpxcommand-から継承されます\"></a><h2 id=\"コマンド-プラグインは-mpxcommand-から継承されます\">コマンド プラグインは MPxCommand から継承されます。</h2></div>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-python\">class Py1HelloWorldCmd(OpenMayaMPx.MPxCommand):\n\
    kPluginCmdName = &quot;py1HelloWorld&quot;\n\
</pre></div><div class=\'section\'><a id=\"コマンドをインスタンス化する\"></a><h2 id=\"コマンドをインスタンス化する\">コマンドをインスタンス化する</h2></div>\n\
<p>コマンドは、<span class=\'code\'>cmdCreator()</span> を使用してインスタンス化されます。<span class=\'code\'>doIt()</span> はコマンドのアクションを実行します。より複雑なコマンド プラグインでは、<span class=\'code\'>doIt()</span> を使用して引数を解析し、内部データを設定し、その他のハウスキーピング処理を行ってから、<span class=\'code\'>redoIt()</span> 関数を呼び出します。その後、<span class=\'code\'>redoIt()</span> 関数はコマンドのアクションを実行します。</p>\n\
<p>詳細については、「<a href=\'#!/url=./dev_help/Maya-Python-API/Command-Plug-in-Basics/DoItAndRedoIt.html\' title=\'\'>doIt() 関数と redoIt() 関数</a>」を参照してください。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-python\">@staticmethod\n\
   def cmdCreator():\n\
        return OpenMayaMPx.asMPxPtr( Py1HelloWorldCmd() )\n\
\n\
        def doIt(self,argList):\n\
            print (&quot;Hello World!&quot;)\n\
</pre></div><div class=\'section\'><a id=\"プラグインを初期化する\"></a><h2 id=\"プラグインを初期化する\">プラグインを初期化する</h2></div>\n\
<p>すべてのプラグインは、<span class=\'code\'>initializePlugin()</span> 関数を実装する必要があります。次に、この関数が <span class=\'code\'>registerCommand()</span> を呼び出します。<span class=\'code\'>initializePlugin()</span> が実装されていない場合、プラグインのロードは失敗します。詳細については、「<a href=\'#!/url=./dev_help/Maya-Python-API/PluginEntryPoints.html\' title=\'\'>プラグインの初期化と初期化解除</a>」を参照してください。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-python\">def initializePlugin(plugin):\n\
    pluginFn = OpenMayaMPx.MFnPlugin(plugin)\n\
    try:\n\
        pluginFn.registerCommand(\n\
        Py1HelloWorldCmd.kPluginCmdName, Py1HelloWorldCmd.cmdCreator\n\
    )\n\
    except:\n\
        sys.stderr.write(\n\
            &quot;Failed to register command: %s\\n&quot; % Py1HelloWorldCmd.kPluginCmdName\n\
    )\n\
    raise\n\
</pre></div><div class=\'section\'><a id=\"プラグインの初期化を解除する\"></a><h2 id=\"プラグインの初期化を解除する\">プラグインの初期化を解除する</h2></div>\n\
<p>すべてのプラグインは、<span class=\'code\'>uninitializePlugin()</span> 関数を実装する必要があります。次に、この関数が <span class=\'code\'>deregisterCommand()</span> を呼び出します。<span class=\'code\'>uninitializePlugin()</span> が実装されていない場合、プラグインのロードは失敗します。詳細については、「<a href=\'#!/url=./dev_help/Maya-Python-API/PluginEntryPoints.html\' title=\'\'>プラグインの初期化と初期化解除</a>」を参照してください。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-python\">def uninitializePlugin(plugin):\n\
    pluginFn = OpenMayaMPx.MFnPlugin(plugin)\n\
    try:\n\
        pluginFn.deregisterCommand(Py1HelloWorldCmd.kPluginCmdName)\n\
    except:\n\
        sys.stderr.write(\n\
            &quot;Failed to unregister command: %s\\n&quot; % Py1HelloWorldCmd.kPluginCmdName\n\
        )\n\
    raise\n\
</pre></div>      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";