var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../../scripts/prettify.js\"></script><script src=\"../../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>プラグインを設定して保存する</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>プラグインを設定して保存する</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"プラグインを設定して保存する\"></a></div>\n\
<p>プラグインを作成する前に、<a href=\'#!/url=./dev_help/Setting-up-your-build.html\' title=\'\'>環境を設定</a>します。</p>\n\
<p>Maya には、<a href=\'#!/url=./dev_help/Maya-Python-API/Maya-Python-API-1-0.html\' title=\'\'>Maya Python API 1.0</a> と <a href=\'#!/url=./dev_help/Maya-Python-API/Maya-Python-API-2-0.html\' title=\'\'>Maya Python API 2.0</a> という 2 つの異なる Python API が含まれています。Maya Python API 1.0 は、Maya C++ API から生成されます。API 1.0 は Maya Python API 2.0 よりも包括的ですが、API 2.0 ほど Python に近くありません。Maya Python API 2.0 は、Maya Python API 1.0 よりも Python に近くなっています。構造は Python プログラマにとってなじみのあるものになるため、さらに直感的に使用できます。</p>\n\
<p>シンプルな Hello World プラグインには、次の 2 つのバージョンがあります。</p>\n\
<ul>\n\
<li><a href=\'#!/url=./dev_help/A-First-Plugin/Python/HelloWorldAPI1.html\' title=\'\'>Python API 1.0</a> (<a href=\'#!/url=./dev_help/A-First-Plugin/Python/HelloWorldPython1Explained.html\' title=\'\'>説明情報</a>を含む)</li>\n\
<li><a href=\'#!/url=./dev_help/A-First-Plugin/Python/HelloWorldAPI2.html\' title=\'\'>Python API 2.0</a> (<a href=\'#!/url=./dev_help/A-First-Plugin/Python/HelloWorldPython2Explained.html\' title=\'\'>説明情報</a>を含む)</li>\n\
</ul>\n\
<p>エディタを開き、ソース コードを切り取って新しいファイルに貼り付けます。Maya の Python 命名規則に従って、Python API 1.0 ファイルには「py1」というプリフィックス、Python API 2.0 ファイルには「py2」というプリフィックスを付ける必要があります。たとえば、API 1.0 バージョンには「py1HelloWorld.py」という名前を付け、API 2.0 バージョンには「py2HelloWorld.py」という名前を付けることができます。</p>\n\
<p>ファイルを <span class=\'code\'>MAYA_PLUGIN_PATH</span> に保存します。「<a href=\'#!/url=./dev_help/Setting-up-your-build.html\' title=\'\'>ビルド環境を設定する</a>」の指示に従って環境が設定されている場合は、このフォルダに配置されたプラグインが Maya によって自動的に選択されます。</p>\n\
<p>プラグイン マネージャを開きます。<strong>ウィンドウ &gt; 設定/プリファレンス &gt; プラグイン マネージャ(Window &gt; Settings/Preferences &gt; Plug-in Manager)</strong>を選択します。<a href=\'#!/url=./dev_help/LoadingAndUnloadingPlugins/Loading-Samples-Plug-ins-Into-Maya.html\' title=\'\'>プラグインはプラグイン マネージャ(Plug-in Manager)からロード</a>できます。</p>\n\
<p><span class=\'code\'>maya.cmds.loadPlugin()</span> を使用して、スクリプト エディタ(Script Editor)からプラグインをロードすることもできます。例:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-python\">import maya.cmds\n\
maya.cmds.loadPlugin(&quot;py2HelloWorld.py&quot;)\n\
</pre></div><p>プラグインがロードされると、プラグインによって定義されたコマンドが <span class=\'code\'>maya.cmds</span> モジュールに追加されます。これで、スクリプト エディタ(Script Editor)からコマンドを呼び出せるようになりました。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-python\">import maya.cmds as cmds\n\
cmds.py2HelloWorld()\n\
</pre></div><p>コマンドがエコーされ、その下に「Hello World!」が出力されます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-python\">import maya.cmds as cmds\n\
cmds.py2HelloWorld()\n\
Hello World!\n\
</pre></div>      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";