var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../../scripts/prettify.js\"></script><script src=\"../../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>macOS でサンプルをビルドする</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>macOS でサンプルをビルドする</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"macos-でサンプルをビルドする\"></a></div>\n\
<blockquote>\n\
<p><strong>重要:</strong> サンプルをビルドする前に、「<a href=\'#!/url=./dev_help/Setting-up-your-build/Mac-OS-X-environment.html\' title=\'\'>ビルド環境を設定する</a>」の説明に従って環境を設定する必要があります。</p>\n\
</blockquote>\n\
<p>プラグインのサンプルは <span class=\'code\'>$DEVKIT_LOCATION/devkit/plug-ins/</span> に、スタンドアローン アプリケーションのサンプルは <span class=\'code\'>$DEVKIT_LOCATION/devkit/applications/</span> にあります。各サンプルは専用フォルダ内にあります。サンプルをビルドするには、サンプルのフォルダに移動します。</p>\n\
<p>たとえば、<span class=\'code\'>circleNode</span> プラグイン サンプルは <span class=\'code\'>circleNode</span> フォルダ内にあります。このサンプルをビルドするには、<span class=\'code\'>circleNode</span> に移動します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-sh\">cd $DEVKIT_LOCATION/devkit/plug-ins/circleNode\n\
</pre></div><p>サンプルをビルドする前に、<span class=\'code\'>cmake</span> を 1 回実行して、プロジェクトまたは makefile を生成します。</p>\n\
<p>たとえば、</p>\n\
<table class=\'ruled\'>\n\
<tr class=\"header\">\n\
<th align=\"left\">プロジェクト タイプ</th>\n\
<th align=\"left\">cmake コマンド</th>\n\
</tr>\n\
<tr class=\"odd\">\n\
<td align=\"left\">Xcode</td>\n\
<td align=\"left\"><span class=\'code\'>cmake -H. -Bbuild -G Xcode</span></td>\n\
</tr>\n\
<tr class=\"even\">\n\
<td align=\"left\">Makefile</td>\n\
<td align=\"left\"><span class=\'code\'>cmake -H. -Bbuild -G &quot;Unix Makefiles&quot;</span></td>\n\
</tr>\n\
</table>\n\
<p>Apple Silicon では、ターゲット アーキテクチャは既定で arm64 になります。同様に、インテルでは、ターゲット アーキテクチャは既定で Intel x86_64 になります。</p>\n\
<p>CMAKE_OSX_ARCHITECTURE オプションを使用して、両方のアーキテクチャ用にビルドすることもできます。</p>\n\
<p>例:</p>\n\
<table class=\'ruled\'>\n\
<tr class=\"header\">\n\
<th align=\"left\">プロジェクト タイプ</th>\n\
<th align=\"left\">cmake コマンド</th>\n\
</tr>\n\
<tr class=\"odd\">\n\
<td align=\"left\">Xcode</td>\n\
<td align=\"left\"><span class=\'code\'>cmake -H. -Bbuild -G Xcode -DCMAKE_OSX_ARCHITECTURES=&quot;x86_64;arm64&quot;</span></td>\n\
</tr>\n\
<tr class=\"even\">\n\
<td align=\"left\">Makefile</td>\n\
<td align=\"left\"><span class=\'code\'>cmake -H. -Bbuild -G &quot;Unix Makefiles&quot; -DCMAKE_OSX_ARCHITECTURES=&quot;x86_64;arm64&quot;</span></td>\n\
</tr>\n\
</table>\n\
<blockquote>\n\
<p><strong>注:</strong> arm64 と Intel86_64 の両方のビルド時には、1 つのプロジェクトのみが生成されます。</p>\n\
</blockquote>\n\
<p><span class=\'code\'>cmake</span> コマンドがエラーなしで終了して、<span class=\'code\'>build</span> フォルダが作成されます。</p>\n\
<p><span class=\'code\'>cmake</span> を再実行して、サンプルをビルドします。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-sh\">cmake --build build\n\
</pre></div><p>UNIX makefile を使用して実行可能ファイルまたはプラグインをビルドした場合、これらは <span class=\'code\'>build</span> フォルダに配置されます。Xcode プロジェクトを使用してビルドした場合は、<span class=\'code\'>build/Debug</span> フォルダに配置されます。</p>\n\
<p>Xcode プロジェクトを生成した場合は、Xcode からプロジェクトをビルドすることもできます。</p>\n\
<p>プラグインにはサフィックス <span class=\'code\'>bundle</span> が付いています。たとえば、<span class=\'code\'>circleNode</span> プラグインは <span class=\'code\'>circleNode/build/circleNode.bundle</span> という名前になります。</p>\n\
<p>コマンド ラインから実行できるアプリケーションと異なり、プラグインは <a href=\'#!/url=./dev_help/LoadingAndUnloadingPlugins/Loading-Samples-Plug-ins-Into-Maya.html\' title=\'\'>Maya にロードする</a>必要があります。</p>\n\
<blockquote>\n\
<p><strong>重要:</strong> Maya 内に既にロードされているプラグインはリビルドしないでください。<a href=\'#!/url=./dev_help/LoadingAndUnloadingPlugins/Unloading-Plug-ins.html\' title=\'\'>プラグインをアンロード</a>してから、リビルドしてください。</p>\n\
</blockquote>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";