var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../../scripts/prettify.js\"></script><script src=\"../../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>アトリビュートとプラグ</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>アトリビュートとプラグ</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"アトリビュートとプラグ\"></a></div>\n\
<p>ディペンデンシー ノードにはアトリビュートとプラグがあります。</p>\n\
<p>プラグとは、ノード間で入力と出力を渡す手段のことです。アトリビュートを次に示します。</p>\n\
<p>Maya は、<span class=\'code\'>nodeInitializer()</span> の <span class=\'code\'>MPxNode.addAttribute()</span> で追加されたノード アトリビュートを使用して、ノードがディペンデンシー グラフでインスタンス化されたときにノードの入力/出力接続ポイントを定義します。</p>\n\
<p>これらの接続ポイントは<em>プラグ</em>と呼ばれ、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_plug.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MPlug</a></span> のインスタンスによって表されます。<span class=\'code\'>nodeInitializer()</span> の <span class=\'code\'>MPxNode.attributeAffects()</span> への呼び出しは、これらのプラグ間の原因となる入力 &gt; 出力リンクを決定します。最終的に、ディペンデンシー グラフは、すべてのノード間で接続されているプラグの有向エッジを追跡します。Maya のディペンデンシー グラフの継続している評価プロセス中に、プラグに関連付けられたデータが変更された場合は、このプラグが<em>ダーティ</em>としてマークされます。つまり、キャッシュされた値が古いので、値を再計算する必要があります。プラグ階層が再帰的にトラバースされ、残りの影響を受けるプラグがダーティとしてマークされます。</p>\n\
<p>次に、Maya は、ダーティなプラグを含む各ノードで <span class=\'code\'>compute()</span> メソッドを呼び出し、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_plug.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MPlug</a></span> と <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDataBlock\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_data_block.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_data_block.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MDataBlock</a></span> のインスタンスを渡します。渡された <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_plug.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MPlug</a></span> の関連するアトリビュートをチェックし、何を計算するか決定する必要があります。これは、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_plug.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MPlug</a></span> のオーバーロードされた等価演算子「<span class=\'code\'>==</span>」を使用して行います。</p>\n\
<p>渡された <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDataBlock\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_data_block.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_data_block.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MDataBlock</a></span> インスタンスには、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDataHandle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_data_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_data_handle.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MDataHandle</a></span> オブジェクトが含まれます。このオブジェクトには、それぞれのアトリビュートに関連付けられた値が格納されます。<span class=\'code\'>float</span>入力値は、次のように取得されます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">sampleInDataHandle = pDataBlock.inputValue( myNode.sampleInAttribute )\n\
sampleInValue = sampleInDataHandle.asFloat()\n\
</pre></div><p><span class=\'code\'>compute()</span> メソッドは、新たに計算された値を正しい出力 <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDataHandle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_data_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_data_handle.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MDataHandle</a></span> に設定することによって終了する必要があります。<span class=\'code\'>MDataHandle.setClean()</span> への呼び出しによって、対応するプラグからダーティなフラグが除去されます。</p>\n\
<p><span class=\'code\'>compute()</span> 関数に渡されたプラグが計算可能な出力アトリビュートに関連していない場合は、関数が <span class=\'code\'>OpenMaya.kUnknownParameter</span> を返す必要があります。これにより、ベース クラスのいずれかの <span class=\'code\'>compute()</span> 関数を使用してプラグの値を計算する必要があることが Maya に通知されます。</p>\n\
<p>カスタム ノードは、Maya ディペンデンシー グラフ プラグインを作成することによって定義されます。このプラグインには、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_node.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MPxNode</a></span> またはそのいずれかのサブクラスから継承されるクラスが含まれます。この新しいクラスは、<span class=\'code\'>MPxNode.compute()</span> 関数をオーバーライドして、カスタム ノードの動作を定義します。ディペンデンシー グラフ プラグインを Maya にロードしたら、スクリプト エディタを使用してノードのインスタンスを作成することができます。</p>\n\
<div class=\'figure\'><img src=\'images/MayaAttributevsPlug_75%.png\' title=\'\' /></div>\n\
<p>前の図では、<span class=\'code\'>initializePlugin()</span> 関数で <span class=\'code\'>mplugin.registerNode()</span> を呼び出し、パラメータ「<span class=\'code\'>mynode</span>」を渡してカスタム ノードのタイプ名を宣言します。したがって、このノードのインスタンスは、次の Python スクリプトを使用して作成することができます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">import maya.cmds as cmds\n\
cmds.createNode( &quot;mynode&quot; )\n\
</pre></div><p>結果は、プラグインで宣言されたアトリビュート(<span class=\'code\'>nodeInitializer()</span>)に従って入力および出力 <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_plug.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MPlug</a></span> が初期化されるノードのインスタンスになります。具体的には、プラグインで宣言されたアトリビュートは、作成する <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_plug.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MPlug</a></span> のタイプ、既定値、UI での可視性、読み取り可能(入力として使用可能)かどうか、書き込み可能(出力として使用可能)かどうか、およびシーンが保存されるときにランタイム値がファイルに格納されるかどうかを示します。</p>\n\
<p>プラグイン定義の <span class=\'code\'>nodeInitializer()</span> 関数では、次の項目間の<em>作用対象</em>リレーションシップを宣言します。</p>\n\
<ul>\n\
<li><span class=\'code\'>inputAttribute1</span> および <span class=\'code\'>outputAttribute</span>、</li>\n\
<li><span class=\'code\'>inputAttribute2</span> および <span class=\'code\'>outputAttribute</span>。</li>\n\
</ul>\n\
<p><span class=\'code\'>MPxNode.attributeAffects()</span> を使用して宣言された<em>作用対象</em>リレーションシップは、特定の出力を計算するために必要な入力を Maya に伝えます。そのため、ノードの特定のインスタンスで、その <span class=\'code\'>inputAttribute1</span> に関連付けられた <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_plug.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MPlug</a></span> がダーティとマークされている場合、ダーティ フラグは、<span class=\'code\'>outputAttribute</span> に関連付けられている <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_plug.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MPlug</a></span> にも伝播されます。このダーティ フラグの伝播により、ノードの <span class=\'code\'>compute()</span> 関数が呼び出されて、ダーティな <span class=\'code\'>outputAttribute</span> <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_plug.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MPlug</a></span> がクリーンにされます。</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";