var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>Maya セッション外で Python スクリプトを実行する</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>Maya セッション外で Python スクリプトを実行する</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"maya-セッション外で-python-スクリプトを実行する\"></a></div>\n\
<p>Maya Python モジュールを使用する Python スクリプトは、<span class=\'code\'>mayapy</span> などのスタンドアローン Python インタプリタから実行できます。ただし、<span class=\'code\'>mayapy</span> または別の外部インタプリタを使用して Maya セッションの外部から Python スクリプトを実行する場合は、Maya Python モジュールと API を使用する前に、Maya Python ライブラリを読み込んで初期化する必要があります。これにより、ライブラリがロードされ、ライセンスがチェックアウトされ、グラフの状態が初期化されます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-python\">import maya.standalone\n\
maya.standalone.initialize()\n\
</pre></div><p>スクリプトを終了する前に、<span class=\'code\'>maya.standalone.uninitialize()</span> を呼び出します。これにより、ライセンスが返され、Maya ライブラリがアンロードされて、Maya セッションが終了します。</p>\n\
<p>例:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-python\">import maya.standalone\n\
maya.standalone.initialize()\n\
\n\
import maya.cmds\n\
\n\
# script body\n\
\n\
maya.standalone.uninitialize()\n\
</pre></div><blockquote>\n\
<p><strong>注:</strong> スクリプト エディタまたはバッチ プロセスを使用するかどうかに関係なく、<span class=\'code\'>initialize()</span> および <span class=\'code\'>uninitialize()</span> を Maya プロセス内から呼び出すと、Maya Python ライブラリが自動的にロードされ、Maya プロセス内で初期化されるため、エラーが生成されます。Python スクリプトを Maya から、または外部インタプリタから呼び出す場合は、<span class=\'code\'>initialize()</span> および <span class=\'code\'>uninitialize()</span> の呼び出しを Try ブロック内に入れる必要があります。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-python\">try:\n\
  import maya.standalone\n\
  maya.standalone.initialize()\n\
except:\n\
  pass\n\
\n\
try:\n\
  maya.standalone.uninitialize()\n\
except:\n\
  pass\n\
</pre></div></blockquote>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";