var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>ビューポートでレンダー パスをコントロールするスクリプト フラグメントおよびフラグメント グラフを記述する</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>ビューポートでレンダー パスをコントロールするスクリプト フラグメントおよびフラグメント グラフを記述する</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"ビューポートでレンダー-パスをコントロールするスクリプト-フラグメントおよびフラグメント-グラフを記述する\"></a></div>\n\
<div class=\'section\'><a id=\"はじめに\"></a><h2 id=\"はじめに\">はじめに</h2></div>\n\
<p>Maya のビューポートは、次の 2 つの異なるタイプの一連のフラグメント(XML 形式でシリアル化されたスクリプト)を利用します。 * <strong>シェード フラグメント</strong>は、XML 形式の入力および出力定義と共に、コード フラグメントをリアルタイム シェーディング言語(GLSL、HLSL、または Cg)でラップします。このようなフラグメントはネストされたシェード フラグメント グラフに接続され、最終的に、GPU によって実行される最終的なシェーダにコンパイルされます。 * <strong>スクリプト フラグメント</strong>は、一連の必須の<a href=\'#!/url=./dev_help/Viewport-2-0-API/Write-fragments-and-fragment/Script-fragment-commands.html\' title=\'\'>スクリプト コマンド</a>を定義します。これらのコマンドは、実行時に Maya によって解釈され、最終的に GPU 状態が変更されたり、描画が呼び出されたりします。スクリプト フラグメントは、上位のコントロール フローを決定するネストされたスクリプト フラグメント グラフに接続することもできます。</p>\n\
<p>Maya をインストールすると、一連のスクリプト フラグメントおよびフラグメント グラフの XML ファイルがインストール フォルダの <span class=\'code\'>bin/ScriptFragment</span> サブフォルダに格納されます。</p>\n\
<p>Maya 2020 以前のリリースでは、<span class=\'code\'>default.xml</span> は、ビューティ パス(シーンとポスト エフェクト パスを含むが、シャドウ マップとさまざまな UI パスおよび HUD パスは除く)の既定の実装を定義するトップレベルのフラグメント グラフでした。このグラフによって、<span class=\'code\'>Maya_3d_Renderer.xml</span> などのさまざまなフラグメントとフラグメント グラフが接続され、そこから、<span class=\'code\'>HoldOutPasses.xml</span> や <span class=\'code\'>Maya_PostEffects.xml</span> などのフラグメント グラフ、さらに <span class=\'code\'>mayaUIDrawPass.xml</span> や <span class=\'code\'>Maya_SSAO.xml</span> などのフラグメントとフラグメント グラフが順に接続されました(以下同様)。これらのグラフで参照されるフラグメントの一部は、ハードコードされた C++ プロシージャ フラグメントとして実装されます。</p>\n\
<p>Maya の新しいバージョンでも、<span class=\'code\'>default.xml</span> およびそのディペンデンシーは Maya に付属していますが、既定のビューティ パスの実装は再設計されていて、単一のスクリプト フラグメント グラフで示されることはなくなりました。</p>\n\
<p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_render_override.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MRenderOverride</a></span> プラグインでは、ビューティ パスは <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MSceneRender\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_scene_render.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_scene_render.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MSceneRender</a></span> 操作で表されます。<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MSceneRender\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_scene_render.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_scene_render.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MSceneRender</a></span> を構築する場合は、次のように、<span class=\'code\'>fragmentName</span> パラメータを使用して、既定の Maya ビューティパスの実装をオーバーライドするカスタムのスクリプト フラグメントまたはフラグメント グラフの名前を指定することができます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-python\">class FragmentRenderOverride(omr.MRenderOverride):\n\
\n\
    def __init__(self, name):\n\
        self.operatioIndex = 0\n\
        self.operations =  [omr.MSceneRender(&quot;myRendererSameAsMaya&quot;, fragmentName=“customBeauty”),\n\
                           omr.MHUDRender(),\n\
                           omr.MPresentTarget(&quot;present&quot;)]\n\
</pre></div><p>カスタム フラグメントを作成するときに、<span class=\'code\'>bin/ScriptFragment</span> フォルダに含まれている XML ファイルをリファレンスとして使用できますが、Maya の破損を防ぐために、このフォルダ内のファイルを直接変更することはお勧めしません。</p>\n\
<div class=\'section\'><a id=\"api-クラスおよびインタフェース\"></a><h2 id=\"api-クラスおよびインタフェース\">API クラスおよびインタフェース</h2></div>\n\
<p>フラグメント レンダラを作成するための API エントリ ポイントは次のとおりです。これらのインタフェースの使用例については、Developer Kit の <em>viewRenderOverrideFromFragments</em> プラグインおよび「<a href=\'#!/url=./dev_help/Viewport-2-0-API/Write-fragments-and-fragment/Create-a-fragment-renderer-plug.html\' title=\'\'>フラグメント レンダラ サンプル プラグインを作成する</a>」を参照してください。</p>\n\
<ul>\n\
<li>フラグメント マネージャにアクセスするには、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderer::getFragmentManager()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_renderer.html#a0f42783e8eee6f472d6bbb2acb6b2f2d&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_renderer.html#a51f752a7f87444ff57122404b9a6f7b7&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MRenderer::getFragmentManager()</a></span> を呼び出します。スクリプト フラグメントまたはフラグメント グラフを登録するには、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFragmentManager::addFragmentGraphFromFile()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_fragment_manager.html#a222716cf7cc5d67a80ca5be267503813&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_fragment_manager.html#a1e7ecf0b5a2730d8be48c311b44bae1a&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFragmentManager::addFragmentGraphFromFile()</a></span> を呼び出します。</li>\n\
<li>この <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MSceneRender\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_scene_render.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_scene_render.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MSceneRender</a></span> コンストラクタを使用して、シーン レンダーを作成します。このコンストラクタにより、シーンのレンダリングに使用するフラグメント名を指定できます。</li>\n\
</ul>\n\
<p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MSceneRender\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_scene_render.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_scene_render.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MSceneRender</a> (const <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a> &amp;name, const <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a> &amp;fragmentName)</span></p>\n\
<ul>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MSceneRender\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_scene_render.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_scene_render.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MSceneRender</a></span> から派生した、カスタム レンダー操作の 1 つである <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderOperation\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_operation.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_render_operation.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MRenderOperation</a></span> のリストで <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_render_override.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MRenderOverride</a></span> を初期化します。</li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderer::registerOverride()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_renderer.html#ae677d98e2300e2f9c69abb576539ac37&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_renderer.html#a04eef3c7c9f5030e61bb6f4e3ad45e9d&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MRenderer::registerOverride()</a></span> を呼び出して登録します。</li>\n\
<li>レンダー パラメータを取得または設定するには、次の手順を実行します。</li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MSceneRender::getParameters()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_scene_render.html#a426c26adb287500c03beeabeee48851c&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_scene_render.html#af148b038cde45838c9969718ace4dc1f&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MSceneRender::getParameters()</a></span> を呼び出して、レンダラのコントロールに使用される一連のレンダー入力パラメータである <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderParameters\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_parameters.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_render_parameters.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MRenderParameters</a></span> のポインタを返します。</li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderParameters::setParameter()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_parameters.html#aa17e2c9a17b86064950103066fa307ef&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_render_parameters.html#a05a48ff6065d53bea08285c7ca7b164b&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MRenderParameters::setParameter()</a></span> を呼び出して、カスタムの <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MSceneRender\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_scene_render.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_scene_render.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MSceneRender</a></span> で使用されるレンダー フラグメントに値を渡します。</li>\n\
<li>(オプション) <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderScriptCallback\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_script_callback.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MRenderScriptCallback</a></span> クラスから派生して、スクリプト フラグメント <span class=\'code\'>.xml</span> から登録および呼び出し可能なコールバック関数を作成します。<span class=\'code\'>execute()</span> 関数を実装して、現在のレンダー グラフから <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderParameters\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_parameters.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_render_parameters.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MRenderParameters</a></span> を取得し、スクリプトから渡された 3 つのオプション値を取得できるようにします。このメソッドを使用して目的の動作を計算し、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderParameters::setParameter()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_parameters.html#aa17e2c9a17b86064950103066fa307ef&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_render_parameters.html#a05a48ff6065d53bea08285c7ca7b164b&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MRenderParameters::setParameter()</a></span> を呼び出し、スクリプトまたはグラフ内の接続された他のフラグメントに結果を戻します。詳細については、「<a href=\'#!/url=./dev_help/Viewport-2-0-API/Write-fragments-and-fragment/Script-fragment-commands.html\' title=\'\'>スクリプト フラグメント コマンド</a>」トピックの<a href=\'#!/url=./dev_help/Viewport-2-0-API/Write-fragments-and-fragment/Script-fragment-commands.html#call\' title=\'\'>呼び出し</a>コマンドについての説明を参照してください。</li>\n\
</ul>\n\
<p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderer::registerScriptCallback()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_renderer.html#ae60e50cef7a7b5b5a006a74fab479c11&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MRenderer::registerScriptCallback()</a></span> および <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderer::deregisterScriptCallback()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_renderer.html#a8db004785e17022a463c4a195d50c168&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MRenderer::deregisterScriptCallback()</a></span> インタフェースで、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderScriptCallback\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_script_callback.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MRenderScriptCallback</a></span> の登録または登録解除を行うことができます。登録した後に、スクリプト フラグメント .xml で <span class=\'code\'>Call</span> コマンドを使用して、このコールバックを呼び出すことができます。</p>\n\
<div class=\'section\'><a id=\"フラグメントおよびフラグメント-グラフ-xml-の定義\"></a><h2 id=\"フラグメントおよびフラグメント-グラフ-xml-の定義\">フラグメントおよびフラグメント グラフ XML の定義</h2></div>\n\
<div class=\'section\'><a id=\"フラグメントの各部の説明\"></a><h3 id=\"フラグメントの各部の説明\">フラグメントの各部の説明</h3></div>\n\
<p>例については <span class=\'code\'>maya_DepthPrePass.xml</span> を参照してください。</p>\n\
<p>すべてのフラグメントは複合要素 <em>fragment</em> に含まれています。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">&lt;fragment  uiName=&quot;maya_DepthPrePass&quot; name=&quot;maya_DepthPrePass&quot; type=&quot;sceneEffect&quot; class=&quot;ScriptFragment&quot; version=&quot;1.0&quot; feature_level=&quot;30&quot; &gt;\n\
</pre></div><ul>\n\
<li><em>name</em> アトリビュートをフラグメントの内部名に設定します。</li>\n\
<li><em>uiName</em> を内部名と同じに設定したり、外部名を指定したりできます。</li>\n\
<li><em>type</em> アトリビュートを <strong>sceneEffect</strong> に設定します。</li>\n\
<li>フラグメントの場合は、<em>class</em> アトリビュートは <strong>ScriptFrament</strong> に(フラグメント グラフの場合は FragmentGraph に)設定する必要があります。</li>\n\
<li>リリース間の変更を識別するために <em>version</em> アトリビュートを設定します。通常は、この例のようにこの値を 1.0 に設定できます。</li>\n\
<li><em>feature_level</em> アトリビュートを、パス内で使用されるエフェクトおよび機能で必要とされる最大の機能レベル サポートに設定します。たとえば、feature_level 30 は DirectX 10 に相当します。通常、この値は、この例のように 30 に設定すれば十分です。</li>\n\
</ul>\n\
<p>フラグメントの定義には次の要素も含まれています。</p>\n\
<ul>\n\
<li>オプションの <em>description</em> 要素。description は CDATA ブロックでラップされます。</li>\n\
</ul>\n\
<p><span class=\'code\'>&lt;description&gt;        &lt;![CDATA[        depth pre-pass: make depthStencil &amp; linear, readable opaque depth texture]]&gt;    &lt;/description&gt;</span></p>\n\
<ul>\n\
<li>必須の入力パラメータ セットである <em>properties</em>。</li>\n\
</ul>\n\
<p><span class=\'code\'>&lt;type name =&quot;myParam&quot;&gt;</span> 形式を使用します。<em>type</em> はパラメータのタイプ(int、float4 など)、<em>name</em> はパラメータの必須の名前です(セット内で一意である必要があります)。</p>\n\
<p>ここには Maya で事前に定義された既知の入力である preOpaqueUIList、transparentBitmapsList、カメラ、ビューポートなども含まれます。</p>\n\
<p><span class=\'code\'>&lt;properties&gt;        &lt;countedObject  name=&quot;preOpaqueUIList&quot; /&gt;        ....    &lt;/properties&gt;</span></p>\n\
<ul>\n\
<li>入力接続を含まないパラメータの一連の初期 <em>values</em></li>\n\
</ul>\n\
<p>value 要素内で初期値を持つパラメータを定義するには、次の形式を使用します。</p>\n\
<p><span class=\'code\'>&lt;type name =&quot;myParam&quot; value =&quot;…&quot; /&gt;</span></p>\n\
<p>value 文字列の正確な形式は、パラメータのタイプによって決まります。複数の値を指定するには、カンマ区切りリストを使用します。たとえば、「0,1,3」は int3 または float3 パラメータと一致します。</p>\n\
<p>同じ名前を共有するフラグメント グラフ内のすべてのアトリビュートは、これらの値を使用して初期化されます。</p>\n\
<p><span class=\'code\'>&lt;values&gt;        &lt;float4 name=&quot;viewport&quot; value=&quot;0.000000,0.000000,1.000000,1.000000&quot;  /&gt;        ....    &lt;/values&gt;</span></p>\n\
<ul>\n\
<li>一連の出力パラメータである <em>outputs</em>:</li>\n\
</ul>\n\
<p><span class=\'code\'>&lt;outputs&gt;        &lt;target  name=&quot;depthOut&quot; /&gt;        &lt;target  name=&quot;opaquedepthtexture&quot; /&gt;    &lt;/outputs&gt;</span></p>\n\
<ul>\n\
<li>コマンドのリストを含む実装要素。<em>render</em> を <strong>OGS</strong> に、<em>language</em> を <strong>ScriptInterpreter</strong> に設定します。</li>\n\
</ul>\n\
<p>各コマンドは次の形式の単一の要素によって定義されます。</p>\n\
<p><span class=\'code\'>&lt;command     value=&quot;theValue&quot; /&gt;</span></p>\n\
<p><span class=\'code\'>&lt;implementation render=&quot;OGS&quot; language=&quot;ScriptInterpreter&quot; version=&quot;0.1&quot; &gt;        &lt;scriptCommands&gt;            &lt;AcquireTarget name=&quot;localZ&quot; format=&quot;EFORMAT_R32_FLOAT&quot; size=&quot;@finalDesc.size&quot; relSize=&quot;1.0,1.0&quot; msaa=&quot;0&quot; /&gt;            ....        &lt;/scriptCommands&gt;    &lt;/implmentation&gt;</span></p>\n\
<p>使用可能なコマンドのリストについては、「<a href=\'#!/url=./dev_help/Viewport-2-0-API/Write-fragments-and-fragment/Script-fragment-commands.html\' title=\'\'>スクリプト フラグメント コマンド</a>」を参照してください。</p>\n\
<p>コマンドをリストする場合は、記号 @ を使用して、値をローカル値によって設定するのではなく、パラメータから取得するように指定します。たとえば、上記のコード スニペットでは、値は finalDesc パラメータから取得されます。</p>\n\
<div class=\'section\'><a id=\"フラグメント-グラフの各部の定義\"></a><h3 id=\"フラグメント-グラフの各部の定義\">フラグメント グラフの各部の定義</h3></div>\n\
<p>上記のように、さまざまなフラグメントおよびフラグメント グラフを相互に接続して単一のフラグメント グラフを形成できます。</p>\n\
<p>例については <span class=\'code\'>Maya_PostEffects.xml</span> を参照してください。</p>\n\
<p>すべてのフラグメントは次のように複合要素 <em>fragment_graph</em> に含まれています。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">&lt;fragment_graph  name=&quot;Maya_PostEffects&quot; ref=&quot;Maya_PostEffects&quot; class=&quot;FragmentGraph&quot; version=&quot;1.0&quot; feature_level=&quot;0&quot; &gt;\n\
<ul>\n\
<li></li></ul></pre></div><p><em>ref</em> アトリビュートをフラグメント グラフの内部名に設定します。</p>\n\
<li><p><em>name</em> アトリビュートを内部名と同じにしたり、外部名を指定したりできます。</p></li>\n\
<li><p><em>class</em> アトリビュートは <strong>FragmentGraph</strong> に設定する必要があります。</p></li>\n\
\n\
<p>fragment_graph の定義には次の要素も含まれます。</p>\n\
<ul>\n\
<li><em>Fragments</em></li>\n\
</ul>\n\
<p>このグラフに含まれているすべてのフラグメントをリストします。リストの順番は重要ではありません。</p>\n\
<p><span class=\'code\'>&lt;fragments&gt;        &lt;fragment_ref name=&quot;Maya_UI&quot; ref=&quot;mayaUIDrawPass&quot; /&gt;        ....    &lt;/fragments&gt;</span></p>\n\
<p><em>ref</em> アトリビュートをフラグメントの内部名または既定名に設定します。つまり、XML ファイル内の <em>fragment</em> 要素の <em>name</em> アトリビュートで定義された名前に設定します。</p>\n\
<p><em>name</em> アトリビュートを <em>ref</em> アトリビュートと同じ値に設定できます。また、異なるインスタンスで使用するように別の名前に設定することもできます。このように、2 つの異なるパスで同じアトリビュートを使用する場合、そのアトリビュートに 2 つのパスで別々の接続を設定することができます。</p>\n\
<p>たとえば、<span class=\'code\'>Maya_PostEffects.xml</span> を参照してください。<span class=\'code\'>Maya_PostEffects</span> フラグメント グラフにはグラフ <span class=\'code\'>Maya_SSAO</span> が含まれています。</p>\n\
<p><span class=\'code\'>&lt;fragment_ref name=&quot;Maya_SSAO&quot; ref=&quot;Maya_SSAO&quot; /&gt;</span></p>\n\
<p>その後で、<span class=\'code\'>Maya_SSAO.res</span> を <span class=\'code\'>Maya_MotionBlur.input</span> に接続します。</p>\n\
<p><span class=\'code\'>&lt;connect from=&quot;Maya_SSAO.res&quot; to=&quot;Maya_MotionBlur.input&quot; name=&quot;input&quot; /&gt;</span></p>\n\
<p>別のパスまたはフラグメント グラフ内で <span class=\'code\'>Maya_SSAO</span> に対する別の接続を作成する場合は、次の手順を実行します。</p>\n\
<p><span class=\'code\'>&lt;fragment_ref name=&quot;Maya_SSAO_instance1&quot; ref=&quot;Maya_SSAO&quot; /&gt;</span></p>\n\
<p>次のように接続します。</p>\n\
<p>``` <connect from=\"Maya_SSAO_instance1.res\" to=\"Maya_MotionBlur.input\" name=\"input\"></connect></p>\n\
<p>```</p>\n\
<p><span class=\'code\'>Maya_MotionBlur.input</span> は別のフラグメント グラフで異なる入力を受け取ることができるようになりました。</p>\n\
<ul>\n\
<li><em>接続(Connections)</em></li>\n\
</ul>\n\
<p>フラグメント間のすべての接続を指定します。各接続要素は、1 つのプロパティ入力 <em>to</em> に接続された 1 つの出力 <em>from</em> を指定します。</p>\n\
<p>入力に含めることができるのは 1 つの接続のみですが、出力には任意の数の接続を含めることができます。接続されていない入力にはセマンティックで照合されるシステム入力変数を指定するか、または API を通して微調整することができます。</p>\n\
<p><span class=\'code\'>&lt;connections&gt;        &lt;connect from=&quot;mayaPreUIScript.output&quot; to=&quot;Maya_UI.final&quot; name=&quot;final&quot; /&gt;        ....    &lt;/connections&gt;</span></p>\n\
<blockquote>\n\
<p><strong>注:</strong> <span class=\'code\'>final</span>は、操作の最後に結果を描画するバッファを示します。</p>\n\
</blockquote>\n\
<ul>\n\
<li><em>プロパティ</em></li>\n\
</ul>\n\
<p>サブフラグメント/フラグメント グラフの名前とアトリビュート、およびこれを表すために使用する外部名を指定して、未接続のすべての入力パラメータをリストします。</p>\n\
<p>たとえば、次のようになります。</p>\n\
<p><span class=\'code\'>&lt;properties&gt;        &lt;float4  name=&quot;viewport&quot; ref=&quot;Maya_SSAO.viewport&quot; /&gt;        ....    &lt;/properties&gt;</span></p>\n\
<p>Maya_SSAO はサブフラグメント グラフです。このビューポート アトリビュートを公開するには、エイリアス <em>viewport</em> を使用する必要があります。</p>\n\
<ul>\n\
<li><em>値(Values)</em></li>\n\
</ul>\n\
<p>未接続の入力パラメータの初期値を定義します。</p>\n\
<p><span class=\'code\'>&lt;values&gt;        &lt;float4 name=&quot;viewport&quot; value=&quot;0.000000,0.000000,1.000000,1.000000&quot;  /&gt;        ....    &lt;/values&gt;</span></p>\n\
<ul>\n\
<li><em>出力(Outputs)</em></li>\n\
</ul>\n\
<p>ここで出力を指定し、一次出力を最初にリストします。</p>\n\
<p><span class=\'code\'>&lt;outputs&gt;        &lt;target  name=&quot;output&quot; ref=&quot;Maya_UI.output&quot; /&gt;    &lt;/outputs&gt;</span></p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";