var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>Qt および Maya のコントロールにアクセスする</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>Qt および Maya のコントロールにアクセスする</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"qt-および-maya-のコントロールにアクセスする\"></a></div>\n\
<p>Qt を使用して直接作成したコントロールは、通常、Maya の UI コマンドで認識されません。</p>\n\
<p>これらのコントロールは <span class=\'code\'>isUI</span> コマンドでリストされないため、<span class=\'code\'>button</span> などの特定タイプのコントロールのコマンドでは認識されません。作成されたコントロールを認識するのは、<span class=\'code\'>button</span> などのコマンドのみです。</p>\n\
<p>ただし、Qt コントロールに一意の名前を付けるために <span class=\'code\'>setObjectName()</span> を使用した場合は、<span class=\'code\'>control</span> コマンドを使用してコントロールの有無をテストし、コントロールに基本的な操作を実行できます。</p>\n\
<p>たとえば、ボタンに一意の名前を割り当てる場合は、次のようにします。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-cpp\">   button = new MyAction(&quot;Perform Action&quot;);\n\
   button-&gt;setObjectName(&quot;myActionButton&quot;);\n\
</pre></div><p>次に、<span class=\'code\'>control</span> コマンドを使用してボタンを非表示にします。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-sh\">if (`control -q -exists myActionButton`) {\n\
   control -e -visible false myActionButton;\n\
}\n\
</pre></div><p>Qt を使用すると、Maya コマンドによって作成された UI 要素にアクセスできます。</p>\n\
<p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MQtUtil\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_qt_util.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MQtUtil</a></span> C++ クラスには、Maya のコントロール、レイアウト、ウィンドウ、メニュー項目の基本となる Qt オブジェクトを取得するメソッドが用意されています。</p>\n\
<p>たとえば、<span class=\'code\'>checkBox</span> コマンドを使用して <span class=\'code\'>myCheckBox</span> という名前の Maya checkBox コントロールを作成した場合、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MQtUtil::findControl()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_qt_util.html#a4117d34bd18ee0fa108c4952bda68e94&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MQtUtil::findControl()</a></span> クラスを使用して checkBox の <span class=\'code\'>QWidget</span> ポインタを取得し、適切にキャストすることができます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-cpp\">QWidget* control = <a href=\"javascript:void(0)\" data-symbol=\"MQtUtil::findControl\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_qt_util.html#a4117d34bd18ee0fa108c4952bda68e94&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MQtUtil::findControl</a>(&quot;myCheckBox&quot;);\n\
if (control) {\n\
   QCheckBox* cb = qobject_cast&lt;QCheckBox*&gt;(control);\n\
}\n\
<blockquote>\n\
</blockquote></pre></div><p><strong>重要:</strong> コントロールのタイプがキャスト先のタイプと一致しない場合、キャスト操作を行うと <span class=\'code\'>nullptr</span> が返されます。</p>\n\
\n\
<p><span class=\'code\'>QWidget</span> ポインタを使用して <span class=\'code\'>QCheckBox</span> のいずれかのプロパティにアクセスするか、<span class=\'code\'>QCheckBox</span> で任意のメソッドを呼び出すことができます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-cpp\">if (cb) {\n\
    if (cb-&gt;isChecked()) {\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MGlobal::displayInfo\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_global.html#a3d14e9f9ed022a80f664eac0136c2f7a&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MGlobal::displayInfo</a>(&quot;myCheckBox is checked&quot;);\n\
      } else {\n\
          <a href=\"javascript:void(0)\" data-symbol=\"MGlobal::displayInfo\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_global.html#a3d14e9f9ed022a80f664eac0136c2f7a&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MGlobal::displayInfo</a>(&quot;myCheckBox is not checked&quot;);\n\
      }\n\
   }\n\
</pre></div>      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";