var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>loadUI コマンドの使用方法</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>loadUI コマンドの使用方法</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"loadui-コマンドの使用方法\"></a></div>\n\
<p>Qt Creator のフォーム デザイナー ツールを使用すると、グラフィカル インタフェースをインタラクティブに作成し、移植可能な XML 形式で保存できます。Maya には、<span class=\'code\'>loadUI</span> コマンドがあり、MEL や Python のスクリプトで使用してこのようなファイルを Maya にロードし、可能な場合は Maya の標準コントロールに変換できます。</p>\n\
<p>以下の図に、Qt Creator のフォーム デザイナーを使用して作成した、コンボボックス、テキスト フィールド、関連ラベル、下に 2 つのボタンを配置したボタン ボックスで構成された単純なダイアログを示します。</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/loadUI_sample.png\' title=\'\' /></div>\n\
<p>このダイアログをファイル <span class=\'code\'>/home/autodesk/createDialog.ui</span> に保存してから Maya にロードし、以下の MEL コマンドを使用して表示するとします。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-sh\">string $dialog = `loadUI -uiFile &quot;/home/autodesk/createDialog.ui&quot;`;\n\
showWindow $dialog;\n\
</pre></div><p>Python の場合:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-python\">import maya.cmds as cmds\n\
dialog = cmds.loadUI(uiFile=&#39;/home/autodesk/createDialog.ui&#39;)\n\
cmds.showWindow(dialog)\n\
</pre></div><p><span class=\'code\'>loadUI</span> コマンドは、該当する Maya コマンドを実行することで、ファイルで指定したウィジェットを作成します。たとえば、前述の例にある 2 つのラベルは Maya の <span class=\'code\'>text</span> コマンドを使用して作成します。comboBox コントロールは <span class=\'code\'>optionMenu</span> コマンド、入力フィールドは <span class=\'code\'>textField</span> コマンドで作成します。これで、作成したコントロールは通常の手順で作成したかのように MEL と Python のスクリプトで操作できます。</p>\n\
<p>Qt Designer のウィジェットにダイナミック プロパティを追加することによって、コントロールの作成に使用したコマンドにフラグを渡すことができます。このプロパティの名前は、冒頭のハイフンなどを含め、フラグの名前に一致している必要があります(例: <span class=\'code\'>-width</span>)。MEL ではなく Python を使用してコントロールを作成する場合は、冒頭のハイフンを <span class=\'code\'>+</span> に置き換えて <span class=\'code\'>+width</span> のようにします。同一のウィジェットに MEL と Python 両方のフラグを指定すると、動作が定義されないため、エラーとなります。フラグが引数を取る場合は、引数をプロパティの値として指定します。</p>\n\
<p>comboBox で新しいプロパティを作成するには、Qt Designer の緑のプラス記号をクリックします。</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/loadUI_create_property.png\' title=\'\' /></div>\n\
<p>次に、comboBox にプロパティを追加します。</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/loadUI_property.png\' title=\'\' /></div>\n\
<p>対応する optionMenu コントロールを作成すると、<span class=\'code\'>-changeCommand</span> フラグが設定されてコマンド文字列 <span class=\'code\'>newObjectType()</span> が実行されます。</p>\n\
<p><span class=\'code\'>loadUI</span> コマンドで同等の Maya コントロールのない Qt ウィジェットを検出した場合でも、Qt ウィジェットが作成されますが、MEL または Python のスクリプトからアクセスすることはできません。この例として、ダイアログの下部にあるボタン ボックスを挙げます。ここでは、Maya に該当するコントロールがない QDialogButtonBox ウィジェットを使用しています。このため、ボタン ボックス自体もその中にあるボタンにもアクセスできません。ボタン ボックスを使用せずにダイアログに個別にボタンを配置した場合、<span class=\'code\'>loadUI</span> コマンドは Maya の <span class=\'code\'>button</span> コマンドを使用してボタンを作成しており、スクリプトへのアクセスが可能になっています。</p>\n\
<p>ファイルのあらゆるレイアウトは汎用レイアウトとして作成されていて、Maya 内からアクセスするには <span class=\'code\'>layout</span> コマンドを使用する必要があります。<span class=\'code\'>formLayout</span>、<span class=\'code\'>columnLayout</span> といった固有のレイアウト タイプ用のコマンドは使用しません。</p>\n\
<p>Maya のコントロールまたはレイアウトには、Qt Designer の <span class=\'code\'>objectName</span> プロパティで指定した名前が付けられます。最上層のウィンドウの名前は一意である必要がありますが、指定した名前が既に使用されている場合は、<span class=\'code\'>loadUI</span> コマンドによって末尾に数字が追加されて一意になります。</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";