var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>Qt プラグインを作成する</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>Qt プラグインを作成する</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"qt-プラグインを作成する\"></a></div>\n\
<p>Qt のクロスプラットフォーム ツールキットを使用すると、Maya のユーザ インタフェースをカスタマイズできます。</p>\n\
<p>Maya には、Qt プラグインに渡される独自のアプリケーション オブジェクトがあります。そのため、ユーザ独自の <span class=\'code\'>QApplication</span> オブジェクトを作成する必要はありません。</p>\n\
<p><span class=\'code\'>QApplication.instance()</span> または <span class=\'code\'>qApp</span> マクロを使用して、Maya の <span class=\'code\'>QApplication</span> オブジェクトの参照を取得することができます。<span class=\'code\'>QApplication.instance()</span> と <span class=\'code\'>qApp</span> を複数回呼び出して、Maya の <span class=\'code\'>QApplication</span> オブジェクトの複数の参照を取得することができます。</p>\n\
<blockquote>\n\
<p><strong>重要:</strong> <span class=\'code\'>QApplication</span> オブジェクトを新規に作成しないでください。</p>\n\
</blockquote>\n\
<p>Maya の <span class=\'code\'>QApplication</span> オブジェクトの参照を取得したら、標準の Qt 呼び出しを使用してプラグイン アプリケーションを作成できます。詳細については、<a href=\'https://doc.qt.io\' title=\'\' target=\'_blank\'>Qt マニュアル</a>を参照してください。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-cpp\">from PySide2.QtCore import Qt\n\
from PySide2.QtWidgets import QApplication, QPushButton\n\
app = QApplication.instance()\n\
button = QPushButton(&quot;About Qt&quot;)\n\
button.clicked.connect(app.aboutQt)\n\
button.setAttribute(Qt.WA_DeleteOnClose)\n\
button.show()\n\
<blockquote>\n\
</blockquote></pre></div><p><strong>注:</strong> Maya と Qt でレイアウトを使用する場合は、Maya と Qt のレイアウトの相互作用について詳細を把握する必要があります。Maya と Qt のレイアウトの連携の詳細については、C++ リファレンス内の MQUtil のマニュアルを参照してください。</p>\n\
\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";